import sys
import string

bad_auth='bad_auth'
not_a_komurl='not_a_komurl'

hostpart="http://localhost:2000"

def komurl(session, path):
   return hostpart + "/wwwkom/(" + `session` + ")/" + path

def htmlquote(s):
   # FIXME: First approximation
   return s

class decodeurl:
   """Decoded WWW-kom URL.

   Usage:  x = decodeurl("/some/url")
   Throws not_a_komurl, or returns an object with the following members:
   pers_no: a number
   cmd: the command
   arglist: any further arguments"""
   
   def __init__(self, url):
      # Assertion: url is on the format "/wwwkom/(4)/cmd?args"
      # or "/wwwkom/cmd?args" where the "?args" part is optional.
      u = string.split(url, '/')
      if len(u) < 3 or u[0] != '' or u[1] != 'wwwkom':
	 raise not_a_komurl, "Too short or bad: " + `u`
      u[0:2] = []
      if u[0][0] == '(' and u[0][-1] == ')':
	 if len(u[0]) < 3:
	    raise not_a_komurl, "Empty session: " + `u[0]`
	 try:
	    self.pers_no = string.atoi(u[0][1:-1])
	 except ValueError:
	    raise not_a_komurl, "Bad session: " + `u[0]`
	 u[0:1] = []
      else:
	 self.pers_no = None
      if len(u) != 1:
	 raise not_a_komurl, "Expected a single command, got " + `u`
      arglist=string.split(u[0], "?")
      if len(arglist) == 1:
	 self.cmd = arglist[0]
	 self.arglist = []
      elif len(arglist) == 2:
	 self.cmd = arglist[0]
	 self.arglist = string.split(arglist[1], "+")
      else:
	 raise not_a_komurl, "Multiple question marks in arglist: " + u[0]

   def as_string(self):
      return hostpart + self.as_string_sans_hostpart()

   def as_string_sans_hostpart(self):
      res = "/wwwkom/"
      if self.pers_no:
	 res = res + "(" + `self.pers_no` + ")/"
      res = res + self.cmd
      if self.arglist:
	 res = res + "?" + string.join(self.arglist, "+")
      print "as_string: returning", res
      sys.stdout.flush()
      return res
