import komhtml

TEXT_FORMAT = """%(text_no)d %(creation_date)s /%(lines)s/ %(author)s<br>
%(recipients)s%(uplinks)s%(marks)s
<h3>rende: %(subject)s</h3>
%(body)s
<p>
%(footnotes)s%(comments)s"""

# TEXT_FORMAT = "%(lines)s%(text_no)d %(creation_date)s"

class pages:
   def list_conf_z_info(self, list, urlformat):
      res="<ul>\n"
      for item in list:
	 cno = item.conf_no()
	 url = urlformat % cno
	 res = (res + '<li><a href="' + url
		+ ('">%s</a>\n' % komhtml.htmlquote(item.conf_name())))
      res = res + "</ul>\n\n"
      return res

   def page(self, title, header, body):
      return ("<html><head><title>" + self.title(title)
	      + "</title></head>\n<body><h1>"
	      + header + "</h1>\n\n" + body + "\n\n</body>")


class sw_pages(pages):
   def title(self, t):
      return "LysKOM: " + t
   
   def ambiguous_login(self, given, matches):
      return self.page("Vem r du?", "Vem r du?",
		       "Det namn du angav, \"" + komhtml.htmlquote(given)
		       + "\", kan vara ngon av fljande personer:\n"
		       + self.list_conf_z_info(matches,
					       komhtml.komurl("%d", "login")))

   def session_redirect(self, newurl):
      return self.page("Omstyrning", "Omstyrning",
		       "Det namn du angett stmmer inte med den URL du angett "
		       + " \r\nEn korrekt URL fr det angivna namnet r\r\n"
		       + '<a href="' + newurl + '">' + newurl + '</a>. '
		       + "<p>Om din Web-lsare hade frsttt felkod 301 hade "
		       + "du inte sett det hr meddelandet")

   def format_footnote(self, footnote, footnote_author):
      return "Kommentar i text " + footnote + footnote_author + "<br>\n"

   def format_comment(self, comment, comment_author):
      return "Kommentar i text " + comment + comment_author + "<br>\n"

   def format_date(self, date):
      return "%04d-%02d-%02d %02d:%02d:%02d" % date[0:6]
      return `date[0]` + "-" + `date[1]` + "-" + `date[2]` \
	     + " " + `date[3]` + ":" + `date[4]` + ":" + `date[5]`

   def format_uplink(self, is_footnote, parent_text, parent_author_name,
		     sent_at, sender_name):
      if is_footnote:
	 res = "Fotnot till text "
      else:
	 res = "Kommentar till text "
      res = res + parent_text + " av " + parent_author_name + "<br>\n"
      if sent_at:
	 res = (res + "&nbsp;&nbsp;Snt: " + self.format_date(sent_at)
		+ "<br>\n")
      if sender_name:
	 res = res + "&nbsp;&nbsp;Snt av: " + sender_name + "<br>\n"
      return res

   def undef_conf(self, conf_no):
      return "Person/mte nummer " + `conf_no` + " (existerar ej/hemlig)"

   def written_by(self, name):
      return " av " + name

   def nonexisting_text(self):
      return " (ej lsbar av dig)"

   def anonymous_author(self):
      return " (anonym frfattare)"

   def nonexistent_author(self, pers_no):
      return " (utplnad/hemlig frfattare nummer " + `pers_no` + ")"

   def format_recipient(self, is_carbon_copy, name, local_no,
			rec_time, sent_time, sender_name):
      if is_carbon_copy:
	 res = "Extra kopiemottagare "
      else:
	 res = "Mottagare "
      res = res + name + " &lt;" + `local_no` + "&gt;<br>\n"
      if rec_time:
	 res = (res + "&nbsp;&nbsp;Mottaget: " + self.format_date(rec_time)
		+ "<br>\n")
      if sent_time:
	 res = (res + "&nbsp;&nbsp;Snt: " + self.format_date(sent_time)
		+ "<br>\n")
      if sender_name:
	 res = res + "&nbsp;&nbsp;Snt av: " + sender_name + "<br>\n"
      return res

   def format_text(self, map):
      if map["lines"] == 1:
	 map["lines"] = "1 rad"
      else:
	 map["lines"] = `map["lines"]` + " rader"
      marks = map["num_marks"]
      if marks == 0:
	 map["marks"] = ""
      elif marks == 1:
	 map["marks"] = "Markerad av en person<br>\n"
      else:
	 map["marks"] = "Markerad av " + `marks` + " personer<br>\n"
      
      return TEXT_FORMAT % map

   def info_unread_conf(self, conf, unread):
      return `unread` + " olsta i " + conf

   def info_unread_conf_many(self, conf):
      return "Mnga olsta i " + conf

   def there_are_more_unread_confs(self):
      return ("\n<p>\nDu har olsta inlgg i nnu fler mten. "
	      + "De kommer att visas nr du har lst ovanstende mten.")

   def login(self, unreadlist, trunc_msg):
      return self.page("Vlkommen", "Vlkommen till LysKOM!",
		       "Du r nu inloggad. "
		       + "Du har olsta inlgg i fljande mten:\n<p>\n"
		       + unreadlist
		       + trunc_msg)
   def text_link(self, texturl, subject, prev_subject, author):
      if subject == prev_subject:
	 return texturl + " " + author
      else:
	 return texturl + " " + subject + "<br>\n" + author

lingo=sw_pages()
