# Login manager
# This is a login manager for WWW-kom, a special-purpose HTTP server.

import socket
import myhttpbase
import base64
import komxx
import string
import myserver
import sys
import komhtml
from language import lingo

# Global variables:
session=None
session_map={}

# Constants used internally in this module:
true=1
false=0

internal_error='internal_error'

class lm(myhttpbase.myhttpbase):
   base = myhttpbase.myhttpbase

   def connect(self, host, port):
      """Connect to a remot port.

      Returns a tuple (status, readfile, writefile) where status
      is true if the connection succeeded, false if the connection
      was refused.  If the call succeeded, readfile will be a file
      opened for reading and writefile a file opened for writing."""

      s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
      try:
	 s.connect(host, port)
      except socket.error, x:
	 if x[1] == "Connection refused":
	    return (false, false, false)
	 else:
	    raise socket.error, x
      r = s.makefile("r");
      w = s.makefile("w");
      s.close()
      return (true, r, w)

   def start_server(self):
      global session_map
      # FIXME: configurable.  Try alternate hosts for load balancing.
      host = "localhost"
      startport = 4899
      (success, r, w) = self.connect(host, startport)
      if success:
	 response = r.readline()
	 # FIXME: check errors
	 list = string.split(response)
	 if len(list) != 2 or list[0] != "WWW-kom":
	    self.log_error("Cannot contact to WWW-kom; got response \""
			   + response + "\"")
	    raise internal_error
	 port = string.atoi(list[1])
	 session_map[self.url.pers_no] = (host, port)
	 r.close()
	 w.close()
	 self.connect_server()
      else:
	 self.log_error("Cannot contact WWW-kom; connection refused")
	 raise internal_error


   def connect_server(self):
      global session_map
      if session_map.has_key(self.url.pers_no):
	 (host, port) = session_map[self.url.pers_no]
	 (success, r, w) = self.connect(host, port)
	 if success:
	    print "Successfully connected to server at", host, port
	    self.session_server_r = r
	    self.session_server_w = w
	 else:
	    print "Server at", host, port, "has died.  Removing records."
	    del session_map[self.url.pers_no]
	 return success
      else:
	 return false

   def forward_query(self):
      print "Forwarding req", string.join([self.command, self.path, self.request_version])
      self.session_server_w.write(
	 string.join([self.command, self.path, self.request_version]))
      self.session_server_w.write("\r\n")
      print "Forwarding headers...", self.headers.headers
      self.session_server_w.writelines(self.headers.headers)
      print "Forwarding endline..."
      self.session_server_w.write("\r\n")
      # Forward the body, if any
      print "Forwarding flush..."
      self.session_server_w.flush()

   def server_side_redirect(self):
      if not self.connect_server():
	 self.start_server()
      self.forward_query()
      while 1:
	 line = self.session_server_r.readline()
	 print "Got a response:", line,
	 if line:
	    self.wfile.write(line)
	 else:
	    break
      self.session_server_r.close()
      self.session_server_w.close()

   def do_GET(self):
      try:
	 self.url = komhtml.decodeurl(self.path)
	 auth = self.headers.getheader('Authorization')
	 if (auth == None):
	    raise komhtml.bad_auth
	 if (self.url.pers_no):
	    self.server_side_redirect()
	 else:
	    [scheme, cookie] = string.split(auth)
	    if (string.lower(scheme) != "basic"):
	       self.log_error("Bad scheme")
	       self.send_error(500)
	       return
	    [self.user, self.password] \
			= string.split(base64.decodestring(cookie), ":")
	    matches = session.lookup_z_name(self.user, true, false)
	    if len(matches) == 0:
	       raise komhtml.bad_auth
	    elif len(matches) == 1:
	       self.redirect(matches[0].conf_no())
	    else:
	       self.respond(lingo.ambiguous_login(self.user, matches))
      except komhtml.bad_auth:
	 self.bad_auth()
      except komhtml.not_a_komurl, arg:
	 if self.path[-1] == "/":
	    self.path = self.path + "index.html"
	 self.base.do_GET(self)
      except internal_error:
	 self.send_error(500)



def test():
   global session
   print "Connecting to " + sys.argv[1] + ":" + sys.argv[2]
   session = komxx.new_session(sys.argv[1], sys.argv[2])
   print "Connected to LysKOM server.  Starting HTTP server"
   httpd = myserver.myserver(('', string.atoi(sys.argv[3])), lm)
   httpd.serve_forever()

if __name__ == '__main__':
   # usage: lm kom-server-host kom-port-number wwwkom-port-number
   test()
