import string
import base64
import komhtml
import myserver
import myhttpbase
import komxx
import sys
import socket
import posix
from language import lingo

session=None
true=1
false=0

system_error='system_error'
internal_error='internal_error'

class State:
   def __init__(self):
      self.password = None		# The correct password

state = State()

def prefetch_author(text, unprefetched_authors):
   if text.prefetch() == komxx.st_ok:
      session.conf(text.author()).prefetch_name()
   else:
      unprefetched_authors.append(text)

def safe_name(conf_no):
   try:
      return session.conf(conf_no).name()
   except komxx.err_conf_zero:
      return None
   except (komxx.err_undef_conf, komxx.err_undef_pers,
	   komxx.err_access, komxx.err_perm):
      return lingo.undef_conf(conf_no)

def safe_author(text_no):
   try:
      return lingo.written_by(
	 session.conf(session.text(text_no).author()).name())
   except (komxx.err_no_such_text):
      return lingo.nonexisting_text()
   except komxx.err_conf_zero:
      return lingo.anonymous_author()
   except (komxx.err_undef_conf, komxx.err_undef_pers):
      return lingo.nonexistent_author(session.text(text_no).author())

def text_as_link(text_no):
   return '<a href="text?' + `text_no` + '">' + `text_no` + '</a>'

class sh(myhttpbase.myhttpbase):

   def send_response(self, code, message=None):
      "As myhttpbase.send_response, but adds an expired Expires field."
      myhttpbase.myhttpbase.send_response(self, code, message)
      self.send_header("Expires", self.date_time_string())
   
   def do_GET(self):
      global state
      try:
	 self.url = komhtml.decodeurl(self.path)
	 auth = self.headers.getheader('Authorization')
	 if not self.url.pers_no:
	    raise system_error, "no session in url"
	 if auth == None:
	    raise system_error, "no auth provided"
	 [scheme, cookie] = string.split(auth)
	 if (string.lower(scheme) != "basic"):
	    raise system_error
	 [user, password] = string.split(base64.decodestring(cookie), ":")
	 print "session.my_login() is", session.my_login()
	 sys.stdout.flush()
	 if session.my_login() == 0:
	    # Not logged in.  Attempt to log in.
	    if state.password:
	       raise system_error, "password set in state"
	    if session.login(self.url.pers_no, password) == komxx.st_ok:
	       state.password = password
	    else:
	       raise komhtml.bad_auth
	 else:
	    # Logged in.  Check password.
	    if self.url.pers_no != session.my_login():
	       raise system_error, "lm contacted wrong sc"
	    if password != state.password:
	       matches = session.lookup_z_name(user, true, false)
	       if len(matches) == 0:
		  raise komhtml.bad_auth
	       elif len(matches) == 1:
		  if self.url.pers_no == matches[0].conf_no():
		     raise komhtml.bad_auth
		  else:
		     self.redirect(matches[0].conf_no())
	       else:
		  self.respond(lingo.ambiguous_login(user, matches))
	 # The user is authenticated.
	 if session.my_login() == 0:
	    raise internal_error, "my_login() is 0 after successful login"
	 mname = "kom_do_" + self.url.cmd
	 method = getattr(self, mname)
	 method()

      except komhtml.bad_auth:
	 self.bad_auth()
      except komhtml.not_a_komurl, emsg:
	 self.send_error(500, emsg)
      except internal_error, str:
	 self.send_error(500, "internal_error" + str)
      except komxx.errno_error:
	 self.send_error(500, "An LysKOM error occured")

   def kom_do_login(self):
      texts_in_conf=50
      confs=20
      while session.prefetch(0, 0, 0,
			     0, texts_in_conf, confs+1,
			     40) == komxx.st_pending:
	 session.block(1000)

      unread_list=session.confs_with_unread()
      trunc=""
      if len(unread_list) > confs:
	 unread_list[-1:]=[]
	 trunc=lingo.there_are_more_unread_confs()
      conflist=[]
      for unread in unread_list:
	 conf=('<a href="conf?' + `unread[0]` + '">' + safe_name(unread[0])
	       + '</a>')
	 min_unread=unread[1]
	 max_unread=unread[2]
	 if min_unread == max_unread:
	    conflist.append(lingo.info_unread_conf(conf, min_unread))
	 else:
	    conflist.append(lingo.info_unread_conf_many(conf))

      self.respond(lingo.login(string.join(conflist, "<br>\n"), trunc))

   def kom_do_text(self):
      if len(self.url.arglist) != 1:
	 raise not_a_komurl
      try:
	 tno = string.atoi(self.url.arglist[0])
      except ValueError:
	 raise not_a_komurl
      text=session.text(tno)
      #
      # Prefetch everything needed to display text TEXT
      #
      author=session.conf(text.author())
      author.prefetch_name()
      for rcpt in text.recipients():
	 session.conf(rcpt.recipient()).prefetch_name()
	 if rcpt.sender() != 0:
	    session.conf(rcpt.sender()).prefetch_name()
      unprefetched_authors=[]
      for uplink in text.uplinks():
	 prefetch_author(session.text(uplink.parent()), unprefetched_authors)
	 if uplink.sender() != 0:
	    session.conf(uplink.sender()).prefetch_name()
      for footnote in text.footnotes_in():
	 prefetch_author(session.text(footnote), unprefetched_authors)
      for comment in text.comments_in():
	 prefetch_author(session.text(comment), unprefetched_authors)
      print "unprefetched_authors: " + `unprefetched_authors`
      for t in unprefetched_authors:
	 if t.exists():
	    session.conf(t.author()).prefetch_name()
      #
      # Format the text
      #
      map={}
      map["text_no"]       = tno
      map["creation_date"] = lingo.format_date(text.creation_time())
      map["lines"]         = text.num_lines()
      map["author"]        = author.name()
      tmp=""
      for rcpt in text.recipients():
	 tmp = tmp + lingo.format_recipient(
	    rcpt.is_carbon_copy(),
	    safe_name(rcpt.recipient()),
	    rcpt.local_no(),
	    rcpt.has_rec_time() and rcpt.rec_time(),
	    rcpt.has_sent_at() and rcpt.sent_at(),
	    safe_name(rcpt.sender()))
      map["recipients"] = tmp
      tmp = ""
      for uplink in text.uplinks():
	 tmp = tmp + lingo.format_uplink(
	    uplink.is_footnote(),
	    text_as_link(uplink.parent()),
	    safe_author(uplink.parent()),
	    uplink.sent_later() and uplink.sent_at(),
	    safe_name(uplink.sender()))
      map["uplinks"] = tmp
      map["num_marks"] = text.num_marks()
      map["subject"] = text.subject()
      map["body"] = text.body()
      tmp=""
      for footnote in text.footnotes_in():
	 tmp = tmp + lingo.format_footnote(text_as_link(footnote),
					   safe_author(footnote))
      map["footnotes"] = tmp
      tmp = ""
      print "comments in: " + `text.comments_in()` + `tno`
      print "comments in: " + `text.comments_in()` + `tno`
      sys.stdout.flush()
      for comment in text.comments_in():
	 tmp = tmp + lingo.format_comment(text_as_link(comment),
					  safe_author(comment))
      map["comments"] = tmp
      self.respond(lingo.page("Text " + `tno`, "Text " + `tno`,
			      lingo.format_text(map)))

   def kom_do_conf(self):
      if len(self.url.arglist) != 1:
	 raise not_a_komurl
      try:
	 cno = string.atoi(self.url.arglist[0])
      except ValueError:
	 raise not_a_komurl
      conf=session.conf(cno)
      print "Gr till mtet"
      sys.stdout.flush()
      if session.goto_conf(cno) != komxx.st_ok:
	 raise not_a_komurl, "Couldn't go to the conf"
      print "Har gtt till mtet"
      sys.stdout.flush()

      # Prefetch information for the list.
      unread_list = ""
      unread=session.list_unread_texts_in_current(20)
      unprefetched_authors=[]
      for (text, level) in unread:
	 prefetch_author(session.text(text), unprefetched_authors)
      for t in unprefetched_authors:
	 if t.exists():
	    session.conf(t.author()).prefetch_name()

      # Format the list of unread texts.
      prev_level = -1
      prev_subject = ""
      for (text, level) in unread:
	 while prev_level < level:
	    prev_level = prev_level + 1
	    unread_list = unread_list + "<ul>\n"
	 while prev_level > level:
	    prev_level = prev_level - 1
	    unread_list = unread_list + "</ul>\n"
	 t = session.text(text)
	 subject = t.subject()
	 unread_list = unread_list + "<li>" + lingo.text_link(
	    text_as_link(text),
	    subject, prev_subject, safe_author(text))
	 prev_subject = subject
      while prev_level > -1:
	 prev_level = prev_level - 1
	 unread_list = unread_list + "</ul>\n"
      self.respond(lingo.page("Olsta", "Olsta i " + safe_name(cno),
			      "Dessa texter r olsta: " + unread_list))


def start_httpd():
   for port in range(8000, 8500):
      try:
	 httpd = myserver.myserver(('', port), sh)
	 print "WWW-kom", port
	 sys.stdout.flush()
	 f=open("/tmp/wwwkomserver." + `posix.getpid()` + ".out", "w")
	 posix.dup2(f.fileno(), 0)
	 posix.dup2(f.fileno(), 1)
	 posix.dup2(f.fileno(), 2)
	 break
      except socket.error:
	 # Try next port in the range
	 pass
   return httpd

def test():
   global session
   httpd = start_httpd()
   session = komxx.new_session(sys.argv[1], sys.argv[2])
   httpd.serve_forever()

if __name__ == '__main__':
   test()
